import { DoctorItem } from "entity";
import { SelectQueryBuilder } from "typeorm";
import CommonHelper from "../helpers/common";
import { OrmHelper } from "../helpers/orm";

export class DoctorItemModel {
    static async list(filter = {}): Promise<SelectQueryBuilder<any>> {
        const repo = OrmHelper.DB.getRepository(DoctorItem);
        let whereAttr: string[] = [];
        let whereVal: any = {};

        if (filter && Object.keys(filter).length > 0) {
            const filterResult = CommonHelper.handleQueryFilter(filter, "DoctorItem");
            whereAttr = [...whereAttr, ...filterResult.whereAttr];
            whereVal = { ...whereVal, ...filterResult.whereVal };
        }

        let query = repo
            .createQueryBuilder("DoctorItem")

        if (whereAttr.length != 0) {
            query = query.where(whereAttr.join(" and "), whereVal);
        }

        return query;
    }
}
